﻿using ActiveUp.Net.Security.OpenPGP;
using BA.Core.Configuration.Form;
using BA.Core.Configuration.Form.Controls.EnumControls;
using BA.Core.CustomAttributes;
using BA.Core.DataProviders;
using BA.Core.DB;
using BA.Core.Enums;
using $safeprojectname$.DataProvider;
using $safeprojectname$.Enums;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Web;

namespace $safeprojectname$.Configuration.Form.Controls
{
    /// <summary>
    /// Combobox mit eigener Auswahlliste (Datenprovider)
    /// 
    /// Falls der eigene Datenprovider keine konfigurierten Werte benötigt, kann er in diesem Konstruktor gesetzt werden. 
    /// Siehe auskommentierter Code. Falls konfigurierte Werte benötigt werden, wird ein Renderer implementiert. 
    /// </summary>
    [Serializable]
    [Toolbox(EnumConfigurationType.FormConfigurationGuid)]
    public class DataProviderCombobox : EnumComboboxControl
    {
        [TokenboxControl]
        [CDPEnumValuesProperties(masterGuid: EnumEngineTypes.Guid)]
        [PropertiesGroup("Spezielle Einstellungen")]
        [DisplayName("Nicht wählbare Werte")]
        [HelpText("Wählen Sie die Werte aus, welche in der Maske nicht ausgewählt werden können.")]
        public string NotSelectableValues { get; set; }

        /// <inheritdoc/>
        public DataProviderCombobox() : base()
        {
            ToolboxName = "Data Provider Combobox";
            ControlInitName = "DataProviderCombobox";
            ToolboxGroupName = "Training";
            Id = new Guid("F2D35360-42E9-44CA-A198-D28BE20947E8");
            Caption = "Data Provider Combobox";
            HasErrors = false;

            // Dies kann genutzt werden, wenn der Datenprovider keine konfigurierten Werte benötigt.
            //DataProviderProperties = new CDPEnumValuesNotUsedProperties
            //{
            //    MasterGuid = EnumEngineTypes.MasterGuid,
            //    NotUsed = new GuidSet(new[] { EnumEngineTypes.PackingMachine.ValueGuid })
            //};
        }
    }
}