﻿using System;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;
using BA.Core;
using BA.Core.CustomAttributes;
using BA.Core.Enums;
using BA.Core.Configuration.Form.Controls;
using BA.Core.Configuration.Form;
using BA.Core.CustomAttributes.Validations;
using BA.Core.Configuration.OrmEntityBase.EntityFields;

namespace BA.Core.Configuration.Form.Controls
{
    /// <summary>
    /// Class used to configure the new control
    /// </summary>
    [Serializable]
    [Toolbox(EnumConfigurationType.FormConfigurationGuid)]
    public class ValueAndAliasControl : DataControlBase, IDevExFormControl
    {
        [BARequired]
        [PropertiesGroup("Spezielle Einstellungen")]
        [HelpText("Geben Sie das Trennzeichen zwischen Wert und Alias an.")]
        [StringLength(1)]
        [DisplayName("Trennzeichen")]
        public String Delimiter { get; set; } = "|";

        /// <summary>
        /// Initializes a new instance of the <see cref="ValueAndAliasControl" /> class.
        /// </summary>
        public ValueAndAliasControl()
        {
            ToolboxName = "Wert und Alias";
            ControlInitName = "ValueAndAlias";
            ToolboxGroupName = "Training";
            Icon = Constants.Icons.Designer.Form.TextEdit;
            Id = new Guid("3429DFE9-8CE0-4A99-A8B6-EDF2866C6D71");
            Caption = "Wert und Alias";
            HasErrors = false;
        }

        /// <inheritdoc/>
        protected override Type[] GetTypesOfOrmFieldName(ConfigurationBase configuration)
        {
            return new[] { typeof(OrmTextField) };
        }
    }
}