﻿using BA.API;
using BA.Core.Configuration.Relations;
using BA.Core.CriteriaOperators;
using BA.Core.DB;
using $safeprojectname$.Enums.Extensions;
using DevExpress.Data.Filtering;
using System;
using System.Linq;

namespace $safeprojectname$.CriteriaOperators.Functions
{
    public class BATResponsible : ICriteriaOperatorBAFunction
    {
        /// <inheritdoc/>
        public virtual CriteriaOperator GetCriteria(CriteriaOperatorBAFunctionPatcher visitor, FunctionOperator function)
        {
            // Sourcetypen ermitteln, um die Ergebnismenge typisieren zu können. Damit kann man auf konkrete Felder des Typs zugreifen.
            RelationTypeConfiguration relType = Api.Config.TryRelation(EnumRelationTypeExtension.Responsible.ValueGuid);
            GuidSet sourceType = GuidSet.Parse(relType.SourceTypes);

            // Hat die Funktion einen Parameter wird dieser als Aggregatsausdruck verwendet.
            if (function.Operands.Count == 2 && function.Operands[1] is CriteriaOperator value)
                return CriteriaOperatorBuilder.GetSourcesJoin(true, EnumRelationTypeExtension.Responsible, null, sourceTypes: sourceType, aggregatedExpression: value);

            return CriteriaOperatorBuilder.GetSourcesJoin(true, EnumRelationTypeExtension.Responsible, null, sourceTypes: sourceType);
        }
    }
}