﻿using BA.Core.Configuration.OrmEntityBase.Validators;
using BA.Core.Configuration.Validators;
using BA.Core.CustomAttributes.Validations;
using $safeprojectname$.Configuration.Validators;
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Web;

namespace $safeprojectname$.CustomAttributes.Validations
{
    /// <summary>
    /// Frühstes Jahr Validator
    /// </summary>
    public class YearAndLaterValidatorAttribute : ValidationAttribute, IDesignableValidator
    {
        public int Year { get; set; }

        public YearAndLaterValidatorAttribute() : base() { }

        public YearAndLaterValidatorAttribute(int year) : base()
        {
            Year = year;
        }

        /// <inheritdoc/>
        public FieldValidatorBase CreateValidatorControl()
        {
            return new YearAndLaterValidator()
            {
                Year = Year,
            };
        }

        /// <inheritdoc/>
        protected override ValidationResult IsValid(Object value, ValidationContext validationContext)
        {
            if (value == null)
                return ValidationResult.Success;

            ErrorMessage = "";
            if (Year > 2020 && value is DateTime valueDate)
            {
                if (valueDate.Year < Year)
                {
                    ErrorMessage = "19A88F7D-0744-4241-BBDC-BD2C85AC74F0".Translate(Year);
                    return new ValidationResult(ErrorMessage, new String[] { validationContext.MemberName });
                }
            }

            return ValidationResult.Success;
        }
    }
}