﻿using BA.Core.CustomAttributes;
using BA.Core.Enums;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Web;

namespace $safeprojectname$.Enums
{
    [EnumDefinition("Engine Types", false, false, true, true, true, true)]
    public class EnumEngineTypes : ValueEnum<EnumEngineTypes>
    {
        public const string Guid = "CC49C2BB-584D-47BF-98CA-7153AB7B7A92";

        public const string PrintingMachineGuid = "AFABDD8E-F233-4A2E-A72F-F65D09193B80";
        public const string PackingMachineGuid = "7D924E88-393D-4CA3-BAAE-3C33F991A2B5";
        public const string MechanicalPressGuid = "A93A551D-54AC-47D4-A374-D98794081F16";

        public static readonly EnumEngineTypes PrintingMachine = new EnumEngineTypes(PrintingMachineGuid, 0, "3D31E87A-1B67-4472-B53A-575BFE2E184B", "Druckmaschine für Zeitungen");
        public static readonly EnumEngineTypes PackingMachine = new EnumEngineTypes(PackingMachineGuid, 1, "5B9E094A-745D-47EA-93C7-A1FD5022374F", "Automatische Verpackung");
        public static readonly EnumEngineTypes MechanicalPress = new EnumEngineTypes(MechanicalPressGuid, 2, "64563A48-4BDF-4D6A-A952-7BE9C90FEF68", "Mechanische Müllpresse");

        [Browsable(false)]
        public string Description { get; set; }

        public EnumEngineTypes(String valueGuid, int sortOrder, String translationGuid, String description) : base(valueGuid, sortOrder, translationGuid)
        {
            Description = description;
        }

        public EnumEngineTypes() { }
    }
}