﻿using BA.Core.CustomAttributes;
using BA.Core.DB;
using $safeprojectname$.CustomAttributes.Validations;
using $safeprojectname$.DB;
using $safeprojectname$.Enums;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;

namespace $safeprojectname$.OrmEvents
{
    [BAOrmEvents(typeof(OrmEngine))]
    public class SetDefaultEngineType : BAOrmEventsBase
    {
        public override void OnCreated(OrmBABase orm)
        {
            OrmEngine engine = (OrmEngine)orm;
            engine.SetEnumValue(nameof(OrmEngine.Type), EnumEngineTypes.MechanicalPress);
        }

        public override void OnAfterOrmValidation(OrmBABase orm, ref bool baseValidationResult)
        {
            OrmEngine engine = (OrmEngine)orm;
            if (engine.Type == null)
            {
                engine.ModelState.AddModelError(nameof(OrmEngine.Type), "Der Typ der Maschine muss gesetzt sein.");
                baseValidationResult = false;
            }
        }
    }
}