﻿using BA.Core.Configuration.Relations;
using BA.Core.Enums;
using BA.Core.Interfaces;
using $safeprojectname$.Enums.Extensions;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;

namespace $safeprojectname$
{
    public class RelationCreation : IRelationCreation
    {
        public void CreateRelationConfigurations(KeyedDictionary<Guid, RelationTypeConfiguration> relationConfigurations)
        {
            relationConfigurations.Add(ResponsibleRelation());
        }

        private RelationTypeConfiguration ResponsibleRelation()
        {
            RelationTypeConfiguration relationConfiguration = new RelationTypeConfiguration()
            {
                Id = EnumRelationTypeExtension.Responsible,
                Type = EnumRelationCardinality.SomethingToAnythingGuid,
            };

            relationConfiguration.Initialize();

            relationConfiguration.SourceTypes.Add(EnumDataSource.UserProfileGuid);
            relationConfiguration.ConfigurationName = "Responsible";
            relationConfiguration.Description = "Responsible relation";
            relationConfiguration.ShowInDesigner = true;

            return relationConfiguration;
        }
    }
}