declare module BA.Ui {
    /**
     * Class to set focus on selected elements
     */
    class DefaultFocus {
        private static query;
        /**
         * Set the default focus in the given area for the best matching element
         * @param area The area we need to process the default focus
         * @param retries The number of retries (default = 3)
         */
        static Focus(area: BA.Ui.DefaultFocus.Area, retries?: number): void;
        /**
         * Set the default focus on sub records
         * @param subRecordContainer The element containing the sub records we need to set the default focus
         * @param retries The number of retries (default = 3)
         * @param index The index of the subrecord we need to set the default focus (if no index is specified we use the last one)
         */
        static SubRecordFocus(subRecordContainer: HTMLElement, retries?: number, index?: number): void;
        /**
         * If we have an element we can focus it and maybe even set the selection range
         * (to set the cursor at the last position in the field)
         * @param element The element we possibly found from the area in the 'Focus'-method
         * @param scrollIntoView Should we scroll to the view or let the autoscroll of the browser happen?
         */
        private static ProcessElement;
    }
    /**
     * Area enum
     */
    namespace DefaultFocus {
        enum Area {
            Form = 0,
            Dialog = 1,
            Grid = 2
        }
    }
}
