declare module BA.Ui.Grid {
    class GridEvents {
        private static defaultFocusDone;
        static OnInit(grid: BAClientGridView, e: ASPxClientEventArgs): void;
        static OnGridFormSuccess(s: any, e: any): boolean | void;
        static OnGridFormFailure(s: any, e: any): void;
        static OnBeginCallback(grid: BAClientGridView, e: MVCxClientBeginCallbackEventArgs): void;
        static OnEndCallback(grid: BAClientGridView, e: ASPxClientEndCallbackEventArgs): void;
        static OnResize(s: any, e: any): void;
        static OnSelectAllClicked(grid: BAClientGridView, e: ASPxClientGridViewSelectionEventArgs): void;
        static OnSelectionChanged(grid: BAClientGridView, e: ASPxClientGridViewSelectionEventArgs): void;
        static OnColumnMoving(s: ASPxClientGridView, e: ASPxClientGridViewColumnMovingEventArgs): void;
        static OnColumnResizing(s: ASPxClientGridView, e: ASPxClientGridViewColumnCancelEventArgs): void;
        static OnRowClick(grid: BAClientGridView, e: ASPxClientGridViewRowClickEventArgs): void | boolean;
        static OpenInPopup(formModel: Models.FormDialogModel, grid: BAClientGridView): void;
        static DefaultSingleClick(grid: BAClientGridView, e: ASPxClientGridViewRowClickEventArgs): void;
        static DefaultDoubleClick(grid: BAClientGridView, e: ASPxClientGridViewRowClickEventArgs): void;
        static TranslationGridDoubleClick(s: BAClientGridView, e: ASPxClientGridViewRowClickEventArgs): void;
        static OnEditStart(grid: any, visibleIndex: any): void;
        /**
         * Save the Layout of a Grid
         * @param button the event button
         * @param evt the event arguments
         */
        static OnLayoutSave(button: BA.Ui.Dialog.BADialogButton, evt: ASPxClientButtonClickEventArgs): void;
        private static _SelectedTextHolder;
        static ContextMenuPopup(s: any, e: any): void;
        static ContextMenuItemClick(s: ASPxClientGridView, e: ASPxClientGridViewContextMenuItemClickEventArgs): void;
        private static TextToClipboard;
        /**
         * Determines what to do, when a menu item of a form detail grid menu is clicked.
         * If the clicked item contains an executable action method id, the context view is set to the custom data and
         * the corresponding action is called. This is identical behavior to the main ribbon bar.
         *
         * @param evt DevExpress event object
         */
        static DetailGridMenu_OnMenuItemClick(evt: DevExpress.ui.dxList.ItemClickEvent): void;
        /**
         * Executed, when a form detail menu bar is initialized and rendered completly.
         * If no item of all the menu bar is visible at all, the menu bar itself will be hidden here.
         *
         * @param evt DevExpress event object
         */
        static DetailGridMenu_OnContentReady(evt: DevExpress.ui.dxList.ContentReadyEvent): void;
        /**
         * Executed, when a drop down (sub menu) is opened.
         * The contained items will not be rendered until the drop down is opened for the first time, so the tooltips
         * need to be applied once more.
         *
         * @param evt DevExpress event object (unknown type, though)
         */
        static DetailGridMenu_OnSubmenuShown(evt: unknown): void;
        /**
        * Executed, when a drop down (sub menu) is closed.
        *
        * @param evt DevExpress event object (unknown type, though)
        */
        static DetailGridMenu_OnSubmenuHidden(evt: unknown): void;
        /**
         * Creates the content of a form detail grid menu item.
         * As I did not find a suitable event to apply tooltips for both normal and collapsed (adaptive) mode, I
         * decided to render the item content myself. This might also come in handy, when the default action for drop
         * down lists is implemented.
         *
         * @param data the custom data of the menu item
         * @param index the index of the menu item in the menu bar
         * @param element the parent jquery node element
         */
        static DetailGridMenu_CreateItem(data: CustomData, index: number, element: JQuery): void;
        private static FocusedFilter;
        static FindFocusedFilterEditor(grid: any): void;
        static SetFocusOnLastFilter(grid: any): void;
    }
}
