declare module BA.Ui.Widgets {
    /**
     * Class for NavigationMenuWidget
     * */
    class NavigationMenuWidget {
        color: string;
        highlightColor: string;
        menuId: string;
        /**
         * Constructor of NavigationMenuWidget
         * @param menuId menu ID
         */
        constructor(menuId: string);
        /**
         * Initialize Navigation Menu
         * */
        Initialize(): void;
        /**
         * Toggle menu item
         * @param menuItem The menu item to toggle.
         */
        ToggleMenuItem(menuItem: JQuery): void;
        /**Ensure Responsiveness for Navigation Menu*/
        ActResponsive(): void;
        /**
         * Change order of Navigation items
         * @param containersPerRow number of containers per row
         */
        ChangeFlexboxOrder(containersPerRow: number): void;
        /**
         * Get the number of columns that fit in a row
         * @param width width of container
         */
        GetColumns(width: number): number;
        /**
         * Ally class to columns
         * @param columnsClass
         * @param element
         */
        ApplyColumnsClass(columnsClass: string, element: JQuery): void;
        /**
         * Change the color of the icon
         * @param parent parent element of icon
         * @param currentClass current class of element
         * @param newClass new class of element
         */
        ChangeIconColor(parent: any, currentClass: string, newClass: string): void;
    }
}
